(setq org-link-custom-types
      '(("mairix" my-mairix-follow-link 
	 my-mairix-store-link gnus-summary-mode)))

(defun my-mairix-follow-link (message-id)
  "Follow a Mairix link."
  (require 'gnus)
  (funcall (cdr (assq 'gnus org-link-frame-setup)))
  (if gnus-other-frame-object (select-frame gnus-other-frame-object))
  (mairix-search message-id))

(defun my-mairix-store-link ()
  "Store a mairix link."
  (let* ((group gnus-newsgroup-name)
	 (article (gnus-summary-article-number))
	 (header (gnus-summary-article-header article))
	 (from (mail-header-from header))
	 (message-id (mail-header-id header))
	 (date (mail-header-date header))
	 (subject (gnus-summary-subject-string)))
    (org-store-link-props :type "mairix" 
			  :from from 
			  :subject subject
			  :message-id message-id 
			  :group group)
    (setq cpltxt (org-email-link-description))
    (setq link (org-make-link "mairix:m:" (substring message-id 1 -1)))))
